/*!
 * malyan v0.0.7
 * https://github.com/HarryChen0506/malyan#readme
 * (c) 2019-2020 
 * MIT License.
 */
'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

var classCallCheck = _classCallCheck;

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

var createClass = _createClass;

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

var defineProperty = _defineProperty;

function createCommonjsModule(fn, module) {
	return module = { exports: {} }, fn(module, module.exports), module.exports;
}

var _typeof_1 = createCommonjsModule(function (module) {
function _typeof(obj) {
  if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
    module.exports = _typeof = function _typeof(obj) {
      return typeof obj;
    };
  } else {
    module.exports = _typeof = function _typeof(obj) {
      return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
    };
  }

  return _typeof(obj);
}

module.exports = _typeof;
});

function _assertThisInitialized(self) {
  if (self === void 0) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return self;
}

var assertThisInitialized = _assertThisInitialized;

function _possibleConstructorReturn(self, call) {
  if (call && (_typeof_1(call) === "object" || typeof call === "function")) {
    return call;
  }

  return assertThisInitialized(self);
}

var possibleConstructorReturn = _possibleConstructorReturn;

var getPrototypeOf = createCommonjsModule(function (module) {
function _getPrototypeOf(o) {
  module.exports = _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
    return o.__proto__ || Object.getPrototypeOf(o);
  };
  return _getPrototypeOf(o);
}

module.exports = _getPrototypeOf;
});

function _superPropBase(object, property) {
  while (!Object.prototype.hasOwnProperty.call(object, property)) {
    object = getPrototypeOf(object);
    if (object === null) break;
  }

  return object;
}

var superPropBase = _superPropBase;

var get = createCommonjsModule(function (module) {
function _get(target, property, receiver) {
  if (typeof Reflect !== "undefined" && Reflect.get) {
    module.exports = _get = Reflect.get;
  } else {
    module.exports = _get = function _get(target, property, receiver) {
      var base = superPropBase(target, property);
      if (!base) return;
      var desc = Object.getOwnPropertyDescriptor(base, property);

      if (desc.get) {
        return desc.get.call(receiver);
      }

      return desc.value;
    };
  }

  return _get(target, property, receiver || target);
}

module.exports = _get;
});

var setPrototypeOf = createCommonjsModule(function (module) {
function _setPrototypeOf(o, p) {
  module.exports = _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
    o.__proto__ = p;
    return o;
  };

  return _setPrototypeOf(o, p);
}

module.exports = _setPrototypeOf;
});

function _inherits(subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function");
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      writable: true,
      configurable: true
    }
  });
  if (superClass) setPrototypeOf(subClass, superClass);
}

var inherits = _inherits;

var Vector =
/*#__PURE__*/
function () {
  function Vector() {
    var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
        x = _ref.x,
        y = _ref.y,
        onChange = _ref.onChange;

    classCallCheck(this, Vector);

    this.x = x || 0;
    this.y = y || 0;
    this.onChange = onChange;
  }

  createClass(Vector, [{
    key: "set",
    value: function set(x, y) {
      this.x = x;
      this.y = y;
    }
  }, {
    key: "clone",
    value: function clone() {
      var _ref2 = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          onChange = _ref2.onChange;

      var instance = new Vector({
        onChange: onChange
      });
      instance.set(this.x, this.y);
      return instance;
    }
  }, {
    key: "x",
    get: function get() {
      return this._x;
    },
    set: function set(v) {
      this._x = v;
      typeof this.onChange === 'function' && this.onChange(this);
    }
  }, {
    key: "y",
    get: function get() {
      return this._y;
    },
    set: function set(v) {
      this._y = v;
      typeof this.onChange === 'function' && this.onChange(this);
    }
  }]);

  return Vector;
}();

defineProperty(Vector, "formatPointIntoVector", function (point) {
  if (Array.isArray(point)) {
    return new Vector({
      x: point[0],
      y: point[1]
    });
  }

  return new Vector(point);
});

function _arrayWithoutHoles(arr) {
  if (Array.isArray(arr)) {
    for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) {
      arr2[i] = arr[i];
    }

    return arr2;
  }
}

var arrayWithoutHoles = _arrayWithoutHoles;

function _iterableToArray(iter) {
  if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter);
}

var iterableToArray = _iterableToArray;

function _nonIterableSpread() {
  throw new TypeError("Invalid attempt to spread non-iterable instance");
}

var nonIterableSpread = _nonIterableSpread;

function _toConsumableArray(arr) {
  return arrayWithoutHoles(arr) || iterableToArray(arr) || nonIterableSpread();
}

var toConsumableArray = _toConsumableArray;

function matrix_invert(M) {
  // M [[0,1], [1,0]]
  // http://blog.acipo.com/matrix-inversion-in-javascript/
  // I use Guassian Elimination to calculate the inverse:
  // (1) 'augment' the matrix (left) by the identity (on the right)
  // (2) Turn the matrix on the left into the identity by elemetry row ops
  // (3) The matrix on the right is the inverse (was the identity matrix)
  // There are 3 elemtary row ops: (I combine b and c in my code)
  // (a) Swap 2 rows
  // (b) Multiply a row by a scalar
  // (c) Add 2 rows
  //if the matrix isn't square: exit (error)
  if (M.length !== M[0].length) {
    return;
  } //create the identity matrix (I), and a copy (C) of the original


  var i = 0,
      ii = 0,
      j = 0,
      dim = M.length,
      e = 0;
  var I = [],
      C = [];

  for (i = 0; i < dim; i += 1) {
    // Create the row
    I[I.length] = [];
    C[C.length] = [];

    for (j = 0; j < dim; j += 1) {
      //if we're on the diagonal, put a 1 (for identity)
      if (i == j) {
        I[i][j] = 1;
      } else {
        I[i][j] = 0;
      } // Also, make the copy of the original


      C[i][j] = M[i][j];
    }
  } // Perform elementary row operations


  for (i = 0; i < dim; i += 1) {
    // get the element e on the diagonal
    e = C[i][i]; // if we have a 0 on the diagonal (we'll need to swap with a lower row)

    if (e == 0) {
      //look through every row below the i'th row
      for (ii = i + 1; ii < dim; ii += 1) {
        //if the ii'th row has a non-0 in the i'th col
        if (C[ii][i] != 0) {
          //it would make the diagonal have a non-0 so swap it
          for (j = 0; j < dim; j++) {
            e = C[i][j]; //temp store i'th row

            C[i][j] = C[ii][j]; //replace i'th row by ii'th

            C[ii][j] = e; //repace ii'th by temp

            e = I[i][j]; //temp store i'th row

            I[i][j] = I[ii][j]; //replace i'th row by ii'th

            I[ii][j] = e; //repace ii'th by temp
          } //don't bother checking other rows since we've swapped


          break;
        }
      } //get the new diagonal


      e = C[i][i]; //if it's still 0, not invertable (error)

      if (e == 0) {
        return;
      }
    } // Scale this row down by e (so we have a 1 on the diagonal)


    for (j = 0; j < dim; j++) {
      C[i][j] = C[i][j] / e; //apply to original matrix

      I[i][j] = I[i][j] / e; //apply to identity
    } // Subtract this row (scaled appropriately for each row) from ALL of
    // the other rows so that there will be 0's in this column in the
    // rows above and below this one


    for (ii = 0; ii < dim; ii++) {
      // Only apply to other rows (we want a 1 on the diagonal)
      if (ii == i) {
        continue;
      } // We want to change this element to 0


      e = C[ii][i]; // Subtract (the row above(or below) scaled by e) from (the
      // current row) but start at the i'th column and assume all the
      // stuff left of diagonal is 0 (which it should be if we made this
      // algorithm correctly)

      for (j = 0; j < dim; j++) {
        C[ii][j] -= e * C[i][j]; //apply to original matrix

        I[ii][j] -= e * I[i][j]; //apply to identity
      }
    }
  } //we've done all operations, C should be the identity
  //matrix I should be the inverse:


  return I;
}
function pageToCanvas(element, clientX, clientY) {
  var rect = element.getBoundingClientRect();
  var x = clientX - rect.left;
  var y = clientY - rect.top;
  return {
    x: x,
    y: y
  };
}
var point = {
  subtract: function subtract(lhs, rhs) {
    return {
      x: lhs.x - rhs.x,
      y: lhs.y - rhs.y
    };
  }
};
var calcPointsRect = function calcPointsRect() {
  var points = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
  var left = Infinity;
  var right = -Infinity;
  var top = Infinity;
  var bottom = -Infinity;

  for (var i = 0; i < points.length; i++) {
    var _point = points[i];

    if (_point[0] <= left) {
      left = _point[0];
    }

    if (_point[0] >= right) {
      right = _point[0];
    }

    if (_point[1] <= top) {
      top = _point[1];
    }

    if (_point[1] >= bottom) {
      bottom = _point[1];
    }
  }

  return {
    left: left,
    right: right,
    top: top,
    bottom: bottom
  };
};
var math = {
  matrix_invert: matrix_invert,
  pageToCanvas: pageToCanvas,
  point: point,
  calcPointsRect: calcPointsRect
};

var EPSILON = function () {
  // return Number.EPSILON ? Number.EPSILON : Math.pow(2, -52)
  return Math.pow(2, -40);
}();

function numberSequal(a, b) {
  return Math.abs(a - b) < EPSILON;
}

var Matrix =
/*#__PURE__*/
function () {
  function Matrix() {
    classCallCheck(this, Matrix);

    this.elements = [];
  }

  createClass(Matrix, [{
    key: "set",
    value: function set() {
      this.elements = Matrix.formatParams.apply(Matrix, arguments);
      return this;
    }
  }, {
    key: "identity",
    value: function identity() {
      this.set(Matrix.Identity);
      return this;
    }
  }, {
    key: "multiply",
    value: function multiply() {
      var B = Matrix.formatParams.apply(Matrix, arguments);
      this.elements = Matrix.multiply(this.elements, B);
      return this;
    }
  }, {
    key: "translate",
    value: function translate(x, y) {
      return this.multiply(1, 0, x, 0, 1, y, 0, 0, 1);
    }
  }, {
    key: "rotate",
    value: function rotate(angle) {
      var c = Math.cos(angle);
      var s = Math.sin(angle);
      return this.multiply(c, -s, 0, s, c, 0, 0, 0, 1);
    }
  }, {
    key: "scale",
    value: function scale(sx, sy) {
      if (sy === undefined) {
        sy = sx;
      }

      return this.multiply(sx, 0, 0, 0, sy, 0, 0, 0, 1);
    }
  }, {
    key: "toString",
    value: function toString() {
      return '[' + this.elements.join(',') + ']';
    }
  }, {
    key: "clone",
    value: function clone() {
      var instance = new Matrix();
      instance.set(this.elements);
      return instance;
    }
  }]);

  return Matrix;
}();

defineProperty(Matrix, "Identity", [1, 0, 0, 0, 1, 0, 0, 0, 1]);

defineProperty(Matrix, "multiply", function (A, B) {
  if (B.length <= 3) {
    // Multiply Vector
    var a = B[0] || 0,
        b = B[1] || 0,
        c = B[2] || 0;
    var x = A[0] * a + A[1] * b + A[2] * c;
    var y = A[3] * a + A[4] * b + A[5] * c;
    var z = A[6] * a + A[7] * b + A[8] * c;
    return {
      x: x,
      y: y,
      z: z
    };
  }

  var A0 = A[0],
      A1 = A[1],
      A2 = A[2];
  var A3 = A[3],
      A4 = A[4],
      A5 = A[5];
  var A6 = A[6],
      A7 = A[7],
      A8 = A[8];
  var B0 = B[0],
      B1 = B[1],
      B2 = B[2];
  var B3 = B[3],
      B4 = B[4],
      B5 = B[5];
  var B6 = B[6],
      B7 = B[7],
      B8 = B[8];
  var res = [A0 * B0 + A1 * B3 + A2 * B6, A0 * B1 + A1 * B4 + A2 * B7, A0 * B2 + A1 * B5 + A2 * B8, A3 * B0 + A4 * B3 + A5 * B6, A3 * B1 + A4 * B4 + A5 * B7, A3 * B2 + A4 * B5 + A5 * B8, A6 * B0 + A7 * B3 + A8 * B6, A6 * B1 + A7 * B4 + A8 * B7, A6 * B2 + A7 * B5 + A8 * B8];
  return res.map(function (v) {
    if (numberSequal(v, 0)) {
      return 0;
    }

    return v;
  });
});

defineProperty(Matrix, "formatParams", function () {
  for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
    args[_key] = arguments[_key];
  }

  if (Array.isArray(args[0])) {
    return args[0];
  }

  var res = [];
  args.forEach(function (v, index) {
    if (isNaN(v)) {
      console.error('Matrix set params is not a number');
    }

    res[index] = v;
  });
  return res;
});

defineProperty(Matrix, "invert", function (M) {
  if (!Array.isArray(M)) {
    console.error('matrix invert params must be n * n array');
    return;
  }

  var rows = Math.sqrt(M.length);
  var origin = [];

  for (var i = 0; i < rows; i++) {
    var item = M.slice(i * rows, i * rows + rows);
    origin.push(item);
  }

  var temp = matrix_invert(origin) || [];
  var res = [];

  for (var _i = 0; _i < temp.length; _i++) {
    res = [].concat(toConsumableArray(res), toConsumableArray(temp[_i]));
  }

  return res;
});

var cloneDeep = function cloneDeep(obj) {
  // Handle the 3 simple types, and null or undefined
  if (obj === null || _typeof_1(obj) !== 'object') return obj; // Handle Date

  if (obj instanceof Date) {
    var _copy = new Date();

    _copy.setTime(obj.getTime());

    return _copy;
  } // Handle Array


  if (obj instanceof Array) {
    var _copy2 = [];
    var len = obj.length;

    for (var i = 0; i < len; ++i) {
      _copy2[i] = cloneDeep(obj[i]);
    }

    return _copy2;
  } // Handle Object


  var copy = {};

  for (var attr in obj) {
    if (Object.prototype.hasOwnProperty.call(obj, attr)) {
      copy[attr] = cloneDeep(obj[attr]);
    }
  }

  return copy;
};
var uuid = function uuid() {
  var s = [];
  var hexDigits = '0123456789abcdef';

  for (var i = 0; i < 36; i++) {
    s[i] = hexDigits.substr(Math.floor(Math.random() * 0x10), 1);
  }

  s[14] = '4'; // bits 12-15 of the time_hi_and_version field to 0010

  s[19] = hexDigits.substr(s[19] & 0x3 | 0x8, 1); // bits 6-7 of the clock_seq_hi_and_reserved to 01

  s[8] = s[13] = s[18] = s[23] = '-';
  var uuid = s.join('');
  return uuid;
};
var isNumber = function isNumber(value) {
  return Object.prototype.toString.call(value) === '[object Number]';
};
var _ = {
  cloneDeep: cloneDeep,
  uuid: uuid,
  isNumber: isNumber
};

var BaseObject =
/*#__PURE__*/
function () {
  function BaseObject() {
    classCallCheck(this, BaseObject);

    this.uuid = _.uuid();
    this.children = [];
    this.parent = null;
  }

  createClass(BaseObject, [{
    key: "add",
    value: function add() {
      var _this = this;

      var objects = [];

      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      if (Array.isArray(args[0])) {
        objects = args[0];
      } else {
        objects = args;
      }

      objects.forEach(function (object) {
        if (object && _this.children) {
          object.parent = _this;

          _this.children.push(object);
        }
      });
    }
  }, {
    key: "remove",
    value: function remove() {
      var _this2 = this;

      var objects = [];

      for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
        args[_key2] = arguments[_key2];
      }

      if (Array.isArray(args[0])) {
        objects = args[0];
      } else {
        objects = args;
      }

      objects.forEach(function (object) {
        if (object && _this2.children) {
          object.parent = null;

          var index = _this2.children.indexOf(object);

          if (index > -1) {
            _this2.children.splice(index, 1);
          }
        }
      });
    }
  }, {
    key: "destroy",
    value: function destroy() {
      if (!this.parent) {
        return;
      }

      var index = this.parent.children.indexOf(this);

      if (index > -1) {
        this.parent.children.splice(index, 1);
      }

      this.parent = null;
    }
  }, {
    key: "clone",
    value: function clone() {
      var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var instance = new this.constructor();
      instance.parent = this.parent;

      if (options.deep) {
        instance.children = this.children.map(function (v) {
          return v.clone && v.clone();
        });
      }

      return instance;
    }
  }]);

  return BaseObject;
}();

var construct = createCommonjsModule(function (module) {
function isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !Reflect.construct) return false;
  if (Reflect.construct.sham) return false;
  if (typeof Proxy === "function") return true;

  try {
    Date.prototype.toString.call(Reflect.construct(Date, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}

function _construct(Parent, args, Class) {
  if (isNativeReflectConstruct()) {
    module.exports = _construct = Reflect.construct;
  } else {
    module.exports = _construct = function _construct(Parent, args, Class) {
      var a = [null];
      a.push.apply(a, args);
      var Constructor = Function.bind.apply(Parent, a);
      var instance = new Constructor();
      if (Class) setPrototypeOf(instance, Class.prototype);
      return instance;
    };
  }

  return _construct.apply(null, arguments);
}

module.exports = _construct;
});

// 拷贝属性 target为子类 source为继承类
function copyProperties(target, source) {
  var _iteratorNormalCompletion = true;
  var _didIteratorError = false;
  var _iteratorError = undefined;

  try {
    for (var _iterator = Reflect.ownKeys(source)[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
      var key = _step.value;

      // name, constructor, prototype之外属性就是实例属性
      if (key !== 'constructor' && key !== 'prototype' && key !== 'name') {
        // 返回某个对象属性的描述对象（ descriptor ）。 参数(对象, 属性)
        var desc = Object.getOwnPropertyDescriptor(source, key);
        Object.defineProperty(target, key, desc);
      }
    }
  } catch (err) {
    _didIteratorError = true;
    _iteratorError = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion && _iterator["return"] != null) {
        _iterator["return"]();
      }
    } finally {
      if (_didIteratorError) {
        throw _iteratorError;
      }
    }
  }
}
function mix() {
  for (var _len = arguments.length, mixins = new Array(_len), _key = 0; _key < _len; _key++) {
    mixins[_key] = arguments[_key];
  }

  var Mix = function Mix() {
    classCallCheck(this, Mix);

    for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
      args[_key2] = arguments[_key2];
    }

    var _iteratorNormalCompletion2 = true;
    var _didIteratorError2 = false;
    var _iteratorError2 = undefined;

    try {
      for (var _iterator2 = mixins[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
        var _class = _step2.value;
        copyProperties(this, construct(_class, args)); // 拷贝实例属性
      }
    } catch (err) {
      _didIteratorError2 = true;
      _iteratorError2 = err;
    } finally {
      try {
        if (!_iteratorNormalCompletion2 && _iterator2["return"] != null) {
          _iterator2["return"]();
        }
      } finally {
        if (_didIteratorError2) {
          throw _iteratorError2;
        }
      }
    }
  };

  for (var _i = 0, _mixins = mixins; _i < _mixins.length; _i++) {
    var mixin = _mixins[_i];
    copyProperties(Mix, mixin); // 拷贝静态属性

    copyProperties(Mix.prototype, mixin.prototype); // 拷贝原型属性
  }

  return Mix;
}

/**
 * Trigger a CustomEvent
 *
 * @param {EventTarget} el The element or EventTarget to trigger the event upon
 * @param {String} type The event type name
 * @param {Object|null} detail=null The event data to be sent
 * @returns {Boolean} The return value is false if at least one event listener called preventDefault(). Otherwise it returns true.
 */
function triggerEvent(el, type) {
  var detail = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
  var event; // This check is needed to polyfill CustomEvent on IE11-

  if (typeof window.CustomEvent === 'function') {
    event = new CustomEvent(type, {
      detail: detail,
      cancelable: true
    });
  } else {
    event = document.createEvent('CustomEvent');
    event.initCustomEvent(type, true, true, detail);
  }

  return el.dispatchEvent(event);
}

var EVENTS = {
  SAVE_DATA: 'saveData',
  CLICK: 'click',
  MOUSE_MOVE: 'mousemove',
  MOUSE_DOWN: 'mousedown',
  MOUSE_UP: 'mouseup',
  MOUSE_DRAG: 'mousedrag',
  MOUSE_ENTER: 'mouseenter',
  MOUSE_LEAVE: 'mouseleave',
  ROOT_CLICK_PRIVATE: 'root:click:private',
  ROOT_MOUSE_DOWN_PRIVATE: 'root:mousedown:private',
  ROOT_MOUSE_MOVE_PRIVATE: 'root:mousemove:private',
  ROOT_MOUSE_DRAG_PRIVATE: 'root:mousedrag:private',
  ROOT_MOUSE_UP_PRIVATE: 'root:mouseup:private',
  OBJECT_CLICK: 'object:click',
  OBJECT_MOUSE_DOWN: 'object:mousedown',
  OBJECT_MOUSE_MOVE: 'object:mousemove',
  OBJECT_MOUSE_UP: 'object:mouseup',
  OBJECT_MOUSE_DRAG: 'object:mousedrag'
};

/**
 * EventTarget - Provides the [EventTarget](https://developer.mozilla.org/en-US/docs/Web/API/EventTarget) interface
 *
 * @class
 * @memberof Polyfills
 */
var EventTarget =
/*#__PURE__*/
function () {
  function EventTarget() {
    classCallCheck(this, EventTarget);

    this.listeners = {};
    this.namespaces = {};
  }

  createClass(EventTarget, [{
    key: "addEventNamespaceListener",
    value: function addEventNamespaceListener(type, callback) {
      if (type === undefined || type === null || type === '') {
        console.error('EventTarget event type cannot be empty');
        return;
      }

      if (type.indexOf('.') <= 0) {
        return;
      }

      this.namespaces[type] = callback;
      this.addEventListener(type.split('.')[0], callback);
    }
  }, {
    key: "removeEventNamespaceListener",
    value: function removeEventNamespaceListener() {
      var type = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';

      if (type.indexOf('.') <= 0 || !this.namespaces[type]) {
        return;
      }

      this.removeEventListener(type.split('.')[0], this.namespaces[type]);
      delete this.namespaces[type];
    }
  }, {
    key: "addEventListener",
    value: function addEventListener(type, callback) {
      if (type === undefined || type === null || type === '') {
        console.error('EventTarget event type cannot be empty');
        return;
      } // Check if it is an event namespace


      if (type.indexOf('.') > 0) {
        this.addEventNamespaceListener(type, callback);
        return;
      }

      if (!(type in this.listeners)) {
        this.listeners[type] = [];
      }

      this.listeners[type].push(callback);
    }
  }, {
    key: "removeEventListener",
    value: function removeEventListener() {
      var type = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';
      var callback = arguments.length > 1 ? arguments[1] : undefined;

      // Check if it is an event namespace
      if (type.indexOf('.') > 0) {
        this.removeEventNamespaceListener(type);
        return;
      }

      if (!(type in this.listeners)) {
        return;
      }

      var stack = this.listeners[type];

      for (var i = 0, l = stack.length; i < l; i++) {
        if (stack[i] === callback) {
          stack.splice(i, 1);
          return;
        }
      }
    }
  }, {
    key: "dispatchEvent",
    value: function dispatchEvent(event) {
      if (!(event.type in this.listeners)) {
        return true;
      }

      var stack = this.listeners[event.type];

      for (var i = 0, l = stack.length; i < l; i++) {
        typeof stack[i] === 'function' && stack[i].call(this, event);
      }

      return !event.defaultPrevented;
    }
  }]);

  return EventTarget;
}();

var isClickEvent = true;
var preventClickTimeout;
var clickDelay = 200;

function preventClickHandler() {
  isClickEvent = false;
}

function mouseDown(e) {
  var element = this;
  preventClickTimeout = setTimeout(preventClickHandler, clickDelay); // 当鼠标mousedown阻止默认move事件，待判断后再在document上注册该move事件

  this.removeEventListener('mousemove', mouseMove);
  var startPoint = {
    client: {
      x: e.clientX,
      y: e.clientY
    },
    page: {
      x: e.pageX,
      y: e.pageY
    },
    canvas: math.pageToCanvas(element, e.clientX, e.clientY)
  };

  var lastPoint = _.cloneDeep(startPoint);

  var currentPoint = _.cloneDeep(startPoint);

  var eventData = {
    event: e,
    element: element,
    startPoint: startPoint,
    lastPoint: lastPoint,
    currentPoint: currentPoint,
    deltaPoint: {
      x: 0,
      y: 0
    },
    type: EVENTS.OBJECT_MOUSE_DOWN
  };
  triggerEvent(eventData.element, EVENTS.ROOT_MOUSE_DOWN_PRIVATE, eventData);

  var onMouseMove = function onMouseMove(e) {
    // console.log('onMouseMove')
    var eventType = EVENTS.ROOT_MOUSE_DRAG_PRIVATE;
    var currentPoint = {
      client: {
        x: e.clientX,
        y: e.clientY
      },
      page: {
        x: e.pageX,
        y: e.pageY
      },
      canvas: math.pageToCanvas(element, e.clientX, e.clientY)
    }; // Calculate delta values in page coordinates

    var deltaPoint = {
      client: math.point.subtract(currentPoint.client, lastPoint.client),
      page: math.point.subtract(currentPoint.page, lastPoint.page),
      canvas: math.point.subtract(currentPoint.canvas, lastPoint.canvas)
    };
    var eventData = {
      event: e,
      element: element,
      startPoint: startPoint,
      lastPoint: lastPoint,
      currentPoint: currentPoint,
      deltaPoint: deltaPoint,
      type: eventType
    };
    triggerEvent(eventData.element, eventType, eventData);
    lastPoint = _.cloneDeep(currentPoint);
  };

  var onMouseUp = function onMouseUp(e) {
    // console.log('onMouseUp')
    clearTimeout(preventClickTimeout);
    var eventType = EVENTS.ROOT_MOUSE_UP_PRIVATE;

    if (isClickEvent) {
      eventType = EVENTS.ROOT_CLICK_PRIVATE;
    }

    var currentPoint = {
      client: {
        x: e.clientX,
        y: e.clientY
      },
      page: {
        x: e.pageX,
        y: e.pageY
      },
      canvas: math.pageToCanvas(element, e.clientX, e.clientY)
    };
    var eventData = {
      event: e,
      element: element,
      type: eventType,
      startPoint: startPoint,
      currentPoint: currentPoint
    };
    triggerEvent(element, eventType, eventData);
    document.removeEventListener('mousemove', onMouseMove);
    document.removeEventListener('mouseup', onMouseUp);
    element.addEventListener('mousemove', mouseMove);
    isClickEvent = true;
  }; // document注册move和up事件


  document.addEventListener('mousemove', onMouseMove);
  document.addEventListener('mouseup', onMouseUp);
}

function mouseMove(e) {
  var eventType = EVENTS.ROOT_MOUSE_MOVE_PRIVATE;
  var element = this;
  var currentPoint = {
    client: {
      x: e.clientX,
      y: e.clientY
    },
    page: {
      x: e.pageX,
      y: e.pageY
    },
    canvas: math.pageToCanvas(element, e.clientX, e.clientY)
  };
  var eventData = {
    event: e,
    element: element,
    currentPoint: currentPoint,
    type: eventType
  };
  triggerEvent(eventData.element, eventType, eventData);
}

function mouseDoubleClick() {// console.log('mouseDoubleClick')
}

function disable(element) {
  element.removeEventListener('mousedown', mouseDown);
  element.removeEventListener('mousemove', mouseMove);
  element.removeEventListener('dblclick', mouseDoubleClick);
}

function enable(element) {
  // Prevent handlers from being attached multiple times
  disable(element);
  element.addEventListener('mousedown', mouseDown);
  element.addEventListener('mousemove', mouseMove);
  element.addEventListener('dblclick', mouseDoubleClick);
}

var mouseEventListeners = {
  enable: enable,
  disable: disable
};

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }
// import _ from '../../utils/tool'
// import math from '../../utils/math'

var MouseDispatchers =
/*#__PURE__*/
function () {
  function MouseDispatchers(_ref) {
    var _this = this;

    var element = _ref.element,
        root = _ref.root;

    classCallCheck(this, MouseDispatchers);

    defineProperty(this, "mouseClick", function (e) {
      // console.log('MouseDispatchers click', this, e)
      // ROOT_CLICK
      var mouse = e.detail.startPoint.canvas;
      var object = null;

      _this.root.tree.traverseDFByPreOrder(function (node) {
        if (node && !node.penetrable) {
          var relativePos = node.calcCanvasToPixelCoordinatePoint([mouse.x, mouse.y]); // console.log('node', node.name, node.calcFinalMatrix())
          // console.log('relativePos', e.detail.startPoint.canvas, relativePos)

          var isInPath = node.containPoint && node.containPoint(_this.root.cacheCtx, relativePos); // console.log('isInPath', isInPath, node.name)

          if (isInPath) {
            object = node;
            node.dispatch && node.dispatch(EVENTS.CLICK, _objectSpread({}, e.detail, {
              target: node
            }));
          }
        }
      }); // emit root click event


      triggerEvent(_this.element, EVENTS.OBJECT_CLICK, _objectSpread({}, e.detail, {
        target: object
      }));
    });

    defineProperty(this, "mouseDrag", function (e) {
      // console.log('MouseDispatchers mouseDrag', e.detail.event.clientX)
      if (_this.dragTarget) {
        _this.dragTarget.dispatch(EVENTS.MOUSE_DRAG, _objectSpread({}, e.detail, {
          target: _this.dragTarget
        }));

        _this.dragTarget.dispatch(EVENTS.MOUSE_MOVE, _objectSpread({}, e.detail, {
          target: _this.dragTarget
        }));

        triggerEvent(_this.element, EVENTS.OBJECT_MOUSE_DRAG, _objectSpread({}, e.detail, {
          target: _this.dragTarget
        }));
      }
    });

    defineProperty(this, "mouseMove", function (e) {
      var mouse = e.detail.currentPoint.canvas;
      var object = null;

      _this.root.tree.traverseDFByPreOrder(function (node) {
        if (node && !node.penetrable) {
          var relativePos = node.calcCanvasToPixelCoordinatePoint([mouse.x, mouse.y]);
          var isInPath = node.containPoint && node.containPoint(_this.root.cacheCtx, relativePos);

          if (isInPath) {
            object = node;
            node.isCurrentMouseIn = true;

            if (node.isLastMouseIn === false) {
              // mouseenter
              typeof node.dispatch === 'function' && node.dispatch(EVENTS.MOUSE_ENTER, _objectSpread({}, e.detail, {
                target: node
              }));
              node.isLastMouseIn = true;
            }

            typeof node.dispatch === 'function' && node.dispatch(EVENTS.MOUSE_MOVE, _objectSpread({}, e.detail, {
              target: node
            }));
          } else {
            node.isCurrentMouseIn = false;

            if (node.isLastMouseIn === true) {
              // mouseleave
              typeof node.dispatch === 'function' && node.dispatch(EVENTS.MOUSE_LEAVE, _objectSpread({}, e.detail, {
                target: node
              }));
              node.isLastMouseIn = false;
            }
          }
        }
      }); // root event


      triggerEvent(_this.element, EVENTS.OBJECT_MOUSE_MOVE, _objectSpread({}, e.detail, {
        target: object
      }));
    });

    defineProperty(this, "mouseDown", function (e) {
      // console.log('mouseDown', e)
      var mouse = e.detail.startPoint.canvas;

      _this.root.tree.traverseDFByPreOrder(function (node) {
        if (node && !node.penetrable) {
          // console.log('node', node.name, node.calcFinalMatrix())
          var relativePos = node.calcCanvasToPixelCoordinatePoint([mouse.x, mouse.y]);
          var isInPath = node.containPoint && node.containPoint(_this.root.cacheCtx, relativePos);

          if (isInPath) {
            _this.dragTarget = node;
          }
        }
      });

      triggerEvent(_this.element, EVENTS.OBJECT_MOUSE_DOWN, _objectSpread({}, e.detail));
    });

    defineProperty(this, "mouseUp", function (e) {
      _this.dragTarget = null;
      triggerEvent(_this.element, EVENTS.OBJECT_MOUSE_UP, _objectSpread({}, e.detail));
    });

    this.element = element;
    this.root = root;
    this.dragTarget = null;
    this.enable();
  }

  createClass(MouseDispatchers, [{
    key: "enable",
    value: function enable() {
      this.element.addEventListener(EVENTS.ROOT_CLICK_PRIVATE, this.mouseClick);
      this.element.addEventListener(EVENTS.ROOT_MOUSE_DOWN_PRIVATE, this.mouseDown);
      this.element.addEventListener(EVENTS.ROOT_MOUSE_MOVE_PRIVATE, this.mouseMove);
      this.element.addEventListener(EVENTS.ROOT_MOUSE_DRAG_PRIVATE, this.mouseDrag);
      this.element.addEventListener(EVENTS.ROOT_MOUSE_UP_PRIVATE, this.mouseUp);
    }
  }, {
    key: "disable",
    value: function disable() {
      this.element.removeEventListener(EVENTS.ROOT_CLICK_PRIVATE, this.mouseClick);
      this.element.removeEventListener(EVENTS.ROOT_MOUSE_DOWN_PRIVATE, this.mouseDown);
      this.element.removeEventListener(EVENTS.ROOT_MOUSE_MOVE_PRIVATE, this.mouseMove);
      this.element.removeEventListener(EVENTS.ROOT_MOUSE_DRAG_PRIVATE, this.mouseDrag);
      this.element.removeEventListener(EVENTS.ROOT_MOUSE_UP_PRIVATE, this.mouseUp);
    }
  }]);

  return MouseDispatchers;
}();

var EventManager =
/*#__PURE__*/
function () {
  function EventManager(_ref) {
    var _this = this;

    var element = _ref.element,
        root = _ref.root;

    classCallCheck(this, EventManager);

    defineProperty(this, "init", function () {
      // 注册鼠标事件
      mouseEventListeners.enable(_this.element);
      _this.MouseDispatchers = new MouseDispatchers({
        element: _this.element,
        root: _this.root
      });
    });

    defineProperty(this, "on", function (eventType, callback) {
      _this.element.addEventListener(eventType, callback);
    });

    defineProperty(this, "off", function (eventType, callback) {
      _this.element.removeEventListener(eventType, callback);
    });

    this.element = element;
    this.root = root;
    this.init();
  }

  createClass(EventManager, [{
    key: "destroy",
    value: function destroy() {
      mouseEventListeners.disable(this.element);
      this.mouseEventDispatchers.disable();
    }
  }]);

  return EventManager;
}();

// So I simply replicated the class to do it.
// const EventTarget = window.EventTarget ? window.EventTarget : CustomEventTarget

var events = new EventTarget();

function ownKeys$1(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread$1(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$1(Object(source), true).forEach(function (key) { defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$1(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }
var defaultConfig = {
  fill: true,
  stroke: true,
  closed: false,
  fillStyle: '#fff',
  strokeStyle: '#000',
  lineWidth: 1,
  opacity: 1,
  shadowColor: 'rgba(0, 0, 0, 0)',
  shadowOffsetX: 0,
  shadowOffsetY: 0,
  shadowBlur: 0,
  lineCap: 'butt',
  lineJoin: 'miter',
  miterLimit: 10,
  lineDash: undefined,
  lineDashOffset: 0,
  penetrable: false,
  onBeforeRender: function onBeforeRender() {},
  onAfterRender: function onAfterRender() {}
};

var Shape =
/*#__PURE__*/
function (_mix) {
  inherits(Shape, _mix);

  function Shape() {
    var _this;

    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    classCallCheck(this, Shape);

    _this = possibleConstructorReturn(this, getPrototypeOf(Shape).call(this, options));

    var config = _objectSpread$1({}, defaultConfig, {}, options);

    _this.name = config.name;
    _this.matrix = new Matrix().identity();
    _this._translation = new Vector({
      x: 0,
      y: 0,
      onChange: _this.onChange.bind(assertThisInitialized(_this))
    });
    _this._scale = new Vector({
      x: 1,
      y: 1,
      onChange: _this.onChange.bind(assertThisInitialized(_this))
    });
    _this._rotation = 0; // preset property

    Object.keys(defaultConfig).forEach(function (key) {
      _this[key] = config[key];
    }); // mouse

    _this.isCurrentMouseIn = false; // is mouse in shape currently

    _this.isLastMouseIn = false; // is mouse in shape last time

    return _this;
  }

  createClass(Shape, [{
    key: "onChange",
    value: function onChange() {
      this.matrix.identity().translate(this.translation.x, this.translation.y).scale(this.scale.x, this.scale.y).rotate(this.rotation); // console.log('onChange transform', transform.toString())
    }
  }, {
    key: "setCtxProps",
    value: function setCtxProps(ctx) {
      if (typeof this.fillStyle === 'function') {
        ctx.fillStyle = this.fillStyle(ctx);
      } else {
        ctx.fillStyle = this.fillStyle;
      }

      if (typeof this.strokeStyle === 'function') {
        ctx.strokeStyle = this.strokeStyle(ctx);
      } else {
        ctx.strokeStyle = this.strokeStyle;
      }

      if (this.stroke) {
        if (this.lineWidth) {
          ctx.lineWidth = this.lineWidth;
        }

        if (this.lineDash) {
          ctx.setLineDash(this.lineDash);
        }

        if (this.miterLimit) {
          ctx.miterLimit = this.miterLimit;
        }

        if (this.lineJoin) {
          ctx.lineJoin = this.lineJoin;
        }

        if (this.lineCap) {
          ctx.lineCap = this.lineCap;
        }
      }

      if (_.isNumber(this.opacity)) {
        ctx.globalAlpha = this.opacity;
      }

      if (this.shadowColor !== defaultConfig.shadowColor) {
        ctx.shadowColor = this.shadowColor;

        if (_.isNumber(this.shadowOffsetX)) {
          ctx.shadowOffsetX = this.shadowOffsetX;
        }

        if (_.isNumber(this.shadowOffsetY)) {
          ctx.shadowOffsetY = this.shadowOffsetY;
        }

        if (_.isNumber(this.shadowBlur)) {
          ctx.shadowBlur = this.shadowBlur;
        }
      }
    }
  }, {
    key: "calcFinalMatrix",
    value: function calcFinalMatrix() {
      var matrices = [this.matrix];
      var parent = this.parent;

      while (parent) {
        matrices.unshift(parent.matrix);
        parent = parent.parent;
      }

      var finalMatrix = matrices[0].elements;

      for (var i = 1; i < matrices.length; i++) {
        finalMatrix = Matrix.multiply(finalMatrix, matrices[i].elements);
      } // console.log('clacFinalMatrix', matrices, finalMatrix)


      return finalMatrix;
    }
  }, {
    key: "calcCanvasToPixelCoordinatePoint",
    value: function calcCanvasToPixelCoordinatePoint() {
      var targetPoint = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [0, 0];

      if (!Array.isArray(targetPoint)) {
        console.error('calcCanvasToPixelCoordinatePoint params must be Array');
      }

      var inverted_matrix = Matrix.invert(this.calcFinalMatrix());
      var relativePos = Matrix.multiply(inverted_matrix, [targetPoint[0], targetPoint[1], 1]);
      return relativePos;
    }
  }, {
    key: "calcPixelToCanvasCoordinatePoint",
    value: function calcPixelToCanvasCoordinatePoint() {
      var targetPoint = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [0, 0];

      if (!Array.isArray(targetPoint)) {
        console.error('calcPixelToCanvasCoordinatePoint params must be Array');
      }

      var matrix = this.calcFinalMatrix();
      return Matrix.multiply(matrix, [targetPoint[0], targetPoint[1], 1]);
    }
  }, {
    key: "calcPixelToParentCoordinatePoint",
    value: function calcPixelToParentCoordinatePoint() {
      var targetPoint = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [0, 0];

      if (!Array.isArray(targetPoint)) {
        console.error('calcPixelToParentCoordinatePoint params must be Array');
      }

      return Matrix.multiply(this.matrix.elements, [targetPoint[0], targetPoint[1], 1]);
    }
  }, {
    key: "calcParentToPixelCoordinatePoint",
    value: function calcParentToPixelCoordinatePoint() {
      var targetPoint = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [0, 0];

      if (!Array.isArray(targetPoint)) {
        console.error('calcPixelToParentCoordinatePoint params must be Array');
      }

      var inverted_matrix = Matrix.invert(this.matrix.elements);
      var relativePos = Matrix.multiply(inverted_matrix, [targetPoint[0], targetPoint[1], 1]);
      return relativePos;
    }
  }, {
    key: "getVertices",
    value: function getVertices() {
      return [];
    }
  }, {
    key: "getRoot",
    value: function getRoot() {
      var parent = this.parent;

      while (parent && parent.parent) {
        parent = parent.parent;
      }

      if (!parent) {
        console.error('scene has not root property', parent);
        return;
      }

      return parent.root;
    }
  }, {
    key: "on",
    value: function on(type, callback) {
      this.addEventListener(type, callback);
    }
  }, {
    key: "dispatch",
    value: function dispatch(type, detail) {
      triggerEvent(this, type, detail);
    }
  }, {
    key: "off",
    value: function off(type, callback) {
      this.removeEventListener(type, callback);
    }
  }, {
    key: "clone",
    value: function clone(options) {
      var _this2 = this;

      var instance = get(getPrototypeOf(Shape.prototype), "clone", this).call(this, options);

      instance.name = this.name;
      instance.matrix = this.matrix.clone();
      instance._translation = this._translation.clone({
        onChange: this.onChange.bind(instance)
      });
      instance._scale = this._scale.clone({
        onChange: this.onChange.bind(instance)
      });
      instance._rotation = this._rotation;
      Object.keys(defaultConfig).forEach(function (key) {
        instance[key] = _this2[key];
      });
      return instance;
    }
  }, {
    key: "translation",
    get: function get() {
      return this._translation;
    },
    set: function set() {
      var v = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      this._translation = new Vector(_objectSpread$1({}, v, {
        onChange: this.onChange.bind(this)
      }));
      this.onChange();
    }
  }, {
    key: "rotation",
    get: function get() {
      return this._rotation;
    },
    set: function set(v) {
      this._rotation = v;
      this.onChange();
    }
  }, {
    key: "scale",
    get: function get() {
      return this._scale;
    },
    set: function set() {
      var v = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {
        x: 1,
        y: 1
      };

      if (_.isNumber(v)) {
        v = {
          x: v,
          y: v
        };
      }

      this._scale = new Vector(_objectSpread$1({}, v, {
        onChange: this.onChange.bind(this)
      }));
      this.onChange();
    }
  }], [{
    key: "calcPixelToSpecificCoordinatePoint",
    value: function calcPixelToSpecificCoordinatePoint() {
      var targetPoint = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [0, 0];
      var matrix = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : new Matrix().identity().elements;

      if (!Array.isArray(targetPoint)) {
        console.error('calcPixelToParentCoordinatePoint params must be Array');
      }

      return Matrix.multiply(matrix, [targetPoint[0], targetPoint[1], 1]);
    }
  }]);

  return Shape;
}(mix(BaseObject, EventTarget));

var Group =
/*#__PURE__*/
function (_Shape) {
  inherits(Group, _Shape);

  function Group() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    classCallCheck(this, Group);

    return possibleConstructorReturn(this, getPrototypeOf(Group).call(this, options));
  }

  createClass(Group, [{
    key: "render",
    value: function render(ctx) {
      this.onBeforeRender && this.onBeforeRender(ctx);
      ctx.save();
      var matrix = this.matrix.elements;
      ctx.transform(matrix[0], matrix[3], matrix[1], matrix[4], matrix[2], matrix[5]);

      for (var i = 0; i < this.children.length; i++) {
        this.children[i] && this.children[i].render(ctx);
      }

      ctx.restore();
      this.onAfterRender && this.onAfterRender(ctx);
    }
  }, {
    key: "clone",
    value: function clone() {
      var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          _ref$deep = _ref.deep,
          deep = _ref$deep === void 0 ? true : _ref$deep;

      var instance = get(getPrototypeOf(Group.prototype), "clone", this).call(this, {
        deep: deep
      });

      return instance;
    }
  }]);

  return Group;
}(Shape);

var Scene =
/*#__PURE__*/
function (_Group) {
  inherits(Scene, _Group);

  function Scene() {
    var _getPrototypeOf2;

    var _this;

    classCallCheck(this, Scene);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = possibleConstructorReturn(this, (_getPrototypeOf2 = getPrototypeOf(Scene)).call.apply(_getPrototypeOf2, [this].concat(args)));
    var options = args[0] || {};
    _this.root = options.root;
    return _this;
  }

  createClass(Scene, [{
    key: "render",
    value: function render(ctx, options) {
      if (options.autoClear) {
        ctx.clearRect(0, 0, ctx.canvas.width, ctx.canvas.height);
      }

      get(getPrototypeOf(Scene.prototype), "render", this).call(this, ctx);
    }
  }]);

  return Scene;
}(Group);

var Tree = function Tree(node) {
  var _this = this;

  classCallCheck(this, Tree);

  defineProperty(this, "traverseDFByPreOrder", function (callback) {
    function recurse(currentNode) {
      callback(currentNode);

      if (!Array.isArray(currentNode.children)) {
        return;
      }

      for (var i = 0, length = currentNode.children.length; i < length; i++) {
        recurse(currentNode.children[i]);
      }
    }

    recurse(_this._root);
  });

  if (!node) {
    console.error('Tree root node cannot be empty');
  }

  this._root = node;
} // 深度优先遍历-先序
;

function ownKeys$2(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread$2(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$2(Object(source), true).forEach(function (key) { defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$2(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }
// import _ from './utils/tool'

/* eslint-disable */

var Malyan =
/*#__PURE__*/
function () {
  function Malyan() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    classCallCheck(this, Malyan);

    this.ctx = null;
    this.cacheCtx = this.createCanvas();
    this.config = _objectSpread$2({}, Malyan.defaultConfig, {}, options);
    this.scene = new Scene({
      name: 'root_group',
      root: this
    });
    this.tree = new Tree(this.scene);
    this.init(this.config);
  }

  createClass(Malyan, [{
    key: "init",
    value: function init() {
      var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      this.initParams(options);
      this.initCtx(options);
      this.initRatio(options);
      this.initSize(options);
      this.initStyle(options);
      this.initEventManager();
    }
  }, {
    key: "initParams",
    value: function initParams() {
      var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var width = options.width,
          height = options.height,
          ratio = options.ratio,
          autoClear = options.autoClear,
          background = options.background;
      this.width = width;
      this.height = height;
      this.ratio = ratio;
      this.autoClear = autoClear;
      this.background = background;
    }
  }, {
    key: "initCtx",
    value: function initCtx() {
      var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var id = options.id,
          context = options.context,
          dom = options.dom;

      if (context) {
        this.ctx = context;
      } else if (dom) {
        context = dom.getContext('2d');
        this.ctx = context;
      } else if (id) {
        dom = document.querySelector('#' + id);
        context = dom.getContext('2d');
        this.ctx = context;
      }

      if (!this.ctx) {
        console.warn('canvas context cannot be null');
      }
    }
  }, {
    key: "initStyle",
    value: function initStyle() {
      if (this.background) {
        this.ctx.canvas.style.background = this.background;
      }
    }
  }, {
    key: "initSize",
    value: function initSize() {
      var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var width = options.width,
          height = options.height;
      this.setSize(width, height);
    }
  }, {
    key: "getSize",
    value: function getSize() {
      return {
        width: this.width,
        height: this.height
      };
    }
  }, {
    key: "setSize",
    value: function setSize(width, height) {
      var canvas = this.ctx.canvas;

      if (width !== undefined) {
        this.width = width;
      }

      if (height !== undefined) {
        this.height = height;
      }

      canvas.style.width = this.width + 'px';
      canvas.style.height = this.height + 'px';
      canvas.width = this.width * this.ratio;
      canvas.height = this.height * this.ratio;
      this.ctx.scale(this.ratio, this.ratio);
    }
  }, {
    key: "initRatio",
    value: function initRatio() {
      var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var context = this.ctx;
      var ratio = options.ratio,
          autoRatio = options.autoRatio;

      if (autoRatio) {
        var devicePixelRatio = window.devicePixelRatio || 1;
        var backingStoreRatio = context.webkitBackingStorePixelRatio || context.mozBackingStorePixelRatio || context.msBackingStorePixelRatio || context.oBackingStorePixelRatio || context.backingStorePixelRatio || 1;
        ratio = devicePixelRatio / backingStoreRatio;
      }

      this.ratio = ratio;
    }
  }, {
    key: "getPixelRatio",
    value: function getPixelRatio() {
      return this.ratio;
    }
  }, {
    key: "createCanvas",
    value: function createCanvas() {
      var dom = document.createElement('canvas');
      var context = dom.getContext('2d');
      return context;
    }
  }, {
    key: "add",
    value: function add() {
      var _this$scene;

      (_this$scene = this.scene).add.apply(_this$scene, arguments);
    }
  }, {
    key: "render",
    value: function render() {
      this.scene.render(this.ctx, {
        autoClear: this.autoClear
      });
    }
  }, {
    key: "forEach",
    value: function forEach(callback) {
      this.tree.traverseDFByPreOrder(function (node) {
        typeof callback === 'function' && callback(node);
      });
    }
  }, {
    key: "initEventManager",
    value: function initEventManager() {
      if (!this.ctx) {
        return;
      }

      this.eventManager = new EventManager({
        element: this.ctx.canvas,
        root: this
      });
    }
  }, {
    key: "on",
    value: function on(eventType, callback) {
      this.eventManager.on(eventType, callback);
    }
  }, {
    key: "off",
    value: function off(eventType, callback) {
      this.eventManager.off(eventType, callback);
    }
  }]);

  return Malyan;
}();

defineProperty(Malyan, "defaultConfig", {
  id: undefined,
  dom: undefined,
  ratio: 1,
  autoRatio: true,
  width: 300,
  height: 150,
  autoClear: true,
  background: undefined
});

var Line =
/*#__PURE__*/
function (_Shape) {
  inherits(Line, _Shape);

  function Line() {
    var _this;

    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    classCallCheck(this, Line);

    _this = possibleConstructorReturn(this, getPrototypeOf(Line).call(this, options));
    var start = options.start,
        end = options.end;
    _this.start = start ? Vector.formatPointIntoVector(start) : new Vector({
      x: 0,
      y: 0
    });
    _this.end = end ? Vector.formatPointIntoVector(end) : new Vector({
      x: 20,
      y: 20
    });
    return _this;
  }

  createClass(Line, [{
    key: "render",
    value: function render(ctx) {
      this.onBeforeRender && this.onBeforeRender(ctx);
      ctx.save();
      var matrix = this.matrix.elements;
      ctx.transform(matrix[0], matrix[3], matrix[1], matrix[4], matrix[2], matrix[5]);
      ctx.beginPath();
      this.setCtxProps && this.setCtxProps(ctx);
      ctx.moveTo(this.start.x, this.start.y);
      ctx.lineTo(this.end.x, this.end.y);
      this.stroke && ctx.stroke();
      ctx.restore();
      this.onAfterRender && this.onAfterRender(ctx);
    }
  }, {
    key: "clone",
    value: function clone() {
      var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          _ref$deep = _ref.deep,
          deep = _ref$deep === void 0 ? true : _ref$deep;

      var instance = get(getPrototypeOf(Line.prototype), "clone", this).call(this, {
        deep: deep
      });

      instance.start = this.start.clone();
      instance.end = this.end.clone();
      return instance;
    }
  }]);

  return Line;
}(Shape);

var Curve =
/*#__PURE__*/
function (_Shape) {
  inherits(Curve, _Shape);

  function Curve() {
    var _this;

    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    classCallCheck(this, Curve);

    _this = possibleConstructorReturn(this, getPrototypeOf(Curve).call(this, options));
    var start = options.start,
        end = options.end,
        _options$controls = options.controls,
        controls = _options$controls === void 0 ? [] : _options$controls;
    _this.start = start ? Vector.formatPointIntoVector(start) : new Vector({
      x: 0,
      y: 0
    });
    _this.end = end ? Vector.formatPointIntoVector(end) : new Vector({
      x: 20,
      y: 20
    });

    if (!Array.isArray(controls)) {
      console.error('Curve controls must be a array');
      _this.controls = [];
    } else {
      _this.controls = controls.map(function (v) {
        return Vector.formatPointIntoVector(v);
      });
    }

    return _this;
  }

  createClass(Curve, [{
    key: "render",
    value: function render(ctx) {
      this.onBeforeRender && this.onBeforeRender(ctx);
      ctx.save();
      var matrix = this.matrix.elements;
      ctx.transform(matrix[0], matrix[3], matrix[1], matrix[4], matrix[2], matrix[5]);
      ctx.beginPath();
      this.setCtxProps && this.setCtxProps(ctx);
      ctx.moveTo(this.start.x, this.start.y);

      if (this.controls.length === 1) {
        ctx.quadraticCurveTo(this.controls[0].x, this.controls[0].y, this.end.x, this.end.y);
      } else if (this.controls.length === 2) {
        ctx.bezierCurveTo(this.controls[0].x, this.controls[0].y, this.controls[1].x, this.controls[1].y, this.end.x, this.end.y);
      }

      if (this.closed) {
        ctx.closePath();
      }

      this.stroke && ctx.stroke();
      this.fill && ctx.fill();
      ctx.restore();
      this.onAfterRender && this.onAfterRender(ctx);
    }
  }, {
    key: "clone",
    value: function clone() {
      var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          _ref$deep = _ref.deep,
          deep = _ref$deep === void 0 ? true : _ref$deep;

      var instance = get(getPrototypeOf(Curve.prototype), "clone", this).call(this, {
        deep: deep
      });

      instance.start = this.start.clone();
      instance.end = this.end.clone();
      instance.controls = this.controls.map(function (v) {
        return v.clone();
      });
      return instance;
    }
  }]);

  return Curve;
}(Shape);

// import Vector from '../../Vector'
var BaseCommandPath =
/*#__PURE__*/
function () {
  function BaseCommandPath() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    classCallCheck(this, BaseCommandPath);

    var name = options.name,
        id = options.id;
    this.name = name;
    this.id = id;
  }

  createClass(BaseCommandPath, [{
    key: "moveTo",
    value: function moveTo(ctx) {
      ctx.moveTo(this.start.x, this.start.y);
    }
  }, {
    key: "render",
    value: function render() {}
  }, {
    key: "clone",
    value: function clone() {
      var instance = new this.constructor();
      instance.name = this.name;
      instance.id = this.id;
      return instance;
    }
  }]);

  return BaseCommandPath;
}();

var CurvePath =
/*#__PURE__*/
function (_BaseCommandPath) {
  inherits(CurvePath, _BaseCommandPath);

  function CurvePath() {
    var _this;

    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    classCallCheck(this, CurvePath);

    _this = possibleConstructorReturn(this, getPrototypeOf(CurvePath).call(this, options));
    CurvePath.validateParams(options);
    var start = options.start,
        end = options.end,
        controls = options.controls;
    _this.controls = controls || [];

    if (start) {
      _this.start = start;
    }

    _this.end = end || new Vector({
      x: 0,
      y: 0
    });
    return _this;
  }

  createClass(CurvePath, [{
    key: "moveTo",
    value: function moveTo(ctx) {
      ctx.moveTo(this.start.x, this.start.y);
    }
  }, {
    key: "render",
    value: function render(ctx) {
      if (this.start) {
        this.moveTo(ctx);
      }

      if (this.controls.length === 1) {
        ctx.quadraticCurveTo(this.controls[0].x, this.controls[0].y, this.end.x, this.end.y);
      } else if (this.controls.length === 2) {
        ctx.bezierCurveTo(this.controls[0].x, this.controls[0].y, this.controls[1].x, this.controls[1].y, this.end.x, this.end.y);
      }
    }
  }, {
    key: "clone",
    value: function clone() {
      var instance = get(getPrototypeOf(CurvePath.prototype), "clone", this).call(this);

      if (this.start) {
        instance.start = this.start.clone();
      }

      instance.end = this.end.clone();
      instance.controls = this.controls.map(function (v) {
        return v.clone();
      });
      return instance;
    }
  }], [{
    key: "validateParams",
    value: function validateParams() {
      var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var end = options.end,
          controls = options.controls;

      if (!end || end.x === undefined || end.y === undefined) {
        console.warn('CurvePath `end` props must be not null in Path.createElements function');
        return false;
      }

      if (!Array.isArray(controls)) {
        console.warn('CurvePath `controls` props must be a array');
        return false;
      }

      return true;
    }
  }]);

  return CurvePath;
}(BaseCommandPath);

var LinePath =
/*#__PURE__*/
function (_BaseCommandPath) {
  inherits(LinePath, _BaseCommandPath);

  function LinePath() {
    var _this;

    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    classCallCheck(this, LinePath);

    _this = possibleConstructorReturn(this, getPrototypeOf(LinePath).call(this, options));
    LinePath.validateParams(options);
    var start = options.start,
        end = options.end;

    if (start) {
      _this.start = start;
    }

    _this.end = end || new Vector({
      x: 0,
      y: 0
    });
    return _this;
  }

  createClass(LinePath, [{
    key: "moveTo",
    value: function moveTo(ctx) {
      ctx.moveTo(this.start.x, this.start.y);
    }
  }, {
    key: "render",
    value: function render(ctx) {
      if (this.start) {
        this.moveTo(ctx);
      }

      ctx.lineTo(this.end.x, this.end.y);
    }
  }, {
    key: "clone",
    value: function clone() {
      var instance = get(getPrototypeOf(LinePath.prototype), "clone", this).call(this);

      if (this.start) {
        instance.start = this.start.clone();
      }

      instance.end = this.end.clone();
      return instance;
    }
  }], [{
    key: "validateParams",
    value: function validateParams() {
      var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var end = options.end;

      if (!end || end.x === undefined || end.y === undefined) {
        console.warn('LinePath `end` props must be not null in Path.createElements function');
        return false;
      }

      return true;
    }
  }]);

  return LinePath;
}(BaseCommandPath);

var ArcPath =
/*#__PURE__*/
function (_BaseCommandPath) {
  inherits(ArcPath, _BaseCommandPath);

  function ArcPath() {
    var _this;

    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    classCallCheck(this, ArcPath);

    _this = possibleConstructorReturn(this, getPrototypeOf(ArcPath).call(this, options));
    ArcPath.validateParams(options);
    var start = options.start,
        x = options.x,
        y = options.y,
        radius = options.radius,
        startAngle = options.startAngle,
        endAngle = options.endAngle,
        anticlockwise = options.anticlockwise;
    _this.x = x || 0;
    _this.y = y || 0;
    _this.radius = radius;
    _this.anticlockwise = anticlockwise || false;
    _this.startAngle = startAngle || 0;
    _this.endAngle = endAngle || Math.PI * 2;
    _this.controls = [];

    if (start) {
      _this.start = start;
    }

    return _this;
  }

  createClass(ArcPath, [{
    key: "moveTo",
    value: function moveTo(ctx) {
      ctx.moveTo(this.start.x, this.start.y);
    }
  }, {
    key: "render",
    value: function render(ctx) {
      if (this.start) {
        this.moveTo(ctx);
      }

      ctx.arc(this.x, this.y, this.radius, this.startAngle, this.endAngle, this.anticlockwise);
    }
  }, {
    key: "clone",
    value: function clone() {
      var instance = get(getPrototypeOf(ArcPath.prototype), "clone", this).call(this);

      if (this.start) {
        instance.start = this.start.clone();
      }

      instance.x = this.x;
      instance.y = this.y;
      instance.radius = this.radius;
      instance.anticlockwise = this.anticlockwise;
      instance.startAngle = this.startAngle;
      instance.endAngle = this.endAngle;
      instance.controls = [];
      return instance;
    }
  }], [{
    key: "validateParams",
    value: function validateParams() {
      var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var radius = options.radius;

      if (radius === undefined) {
        console.warn('ArcPath `radius` props must not be null');
        return false;
      }

      return true;
    }
  }]);

  return ArcPath;
}(BaseCommandPath);

var ArcToPath =
/*#__PURE__*/
function (_BaseCommandPath) {
  inherits(ArcToPath, _BaseCommandPath);

  function ArcToPath() {
    var _this;

    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    classCallCheck(this, ArcToPath);

    _this = possibleConstructorReturn(this, getPrototypeOf(ArcToPath).call(this, options));
    ArcToPath.validateParams(options);
    var start = options.start,
        controls = options.controls,
        radius = options.radius;
    _this.controls = controls || [];
    _this.radius = radius;

    if (start) {
      _this.start = start;
    }

    return _this;
  }

  createClass(ArcToPath, [{
    key: "moveTo",
    value: function moveTo(ctx) {
      ctx.moveTo(this.start.x, this.start.y);
    }
  }, {
    key: "render",
    value: function render(ctx) {
      if (this.start) {
        this.moveTo(ctx);
      }

      ctx.arcTo(this.controls[0].x, this.controls[0].y, this.controls[1].x, this.controls[1].y, this.radius);
    }
  }, {
    key: "clone",
    value: function clone() {
      var instance = get(getPrototypeOf(ArcToPath.prototype), "clone", this).call(this);

      if (this.start) {
        instance.start = this.start.clone();
      }

      instance.radius = this.radius;
      instance.controls = this.controls.map(function (v) {
        return v.clone();
      });
      return instance;
    }
  }], [{
    key: "validateParams",
    value: function validateParams() {
      var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var controls = options.controls;

      if (!Array.isArray(controls)) {
        console.warn('ArcToPath `controls` props must be a array');
        return false;
      }

      if (controls.length !== 2) {
        console.warn('ArcToPath `controls` props array length must be 2');
        return false;
      }

      return true;
    }
  }]);

  return ArcToPath;
}(BaseCommandPath);

function ownKeys$3(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread$3(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$3(Object(source), true).forEach(function (key) { defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$3(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }
var defaultConfig$1 = {
  center: false,
  paths: []
};
var Path =
/*#__PURE__*/
function (_Shape) {
  inherits(Path, _Shape);

  function Path() {
    var _this;

    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    classCallCheck(this, Path);

    _this = possibleConstructorReturn(this, getPrototypeOf(Path).call(this, options));

    var config = _objectSpread$3({}, defaultConfig$1, {}, options);

    Object.keys(defaultConfig$1).forEach(function (key) {
      _this[key] = config[key];
    });

    if (_this.center) {
      _this.setCenter();
    }

    return _this;
  }

  createClass(Path, [{
    key: "render",
    value: function render(ctx) {
      this.onBeforeRender && this.onBeforeRender(ctx);
      ctx.save();
      var matrix = this.matrix.elements;
      ctx.transform(matrix[0], matrix[3], matrix[1], matrix[4], matrix[2], matrix[5]); // begin draw path

      ctx.beginPath();
      this.setCtxProps && this.setCtxProps(ctx);
      var firstPath = this.paths[0];

      if (firstPath) {
        firstPath.moveTo(ctx);
      }

      for (var i = 0; i < this.paths.length; i++) {
        this.paths[i].render(ctx);
      }

      if (this.closed) {
        ctx.closePath();
      }

      this.stroke && ctx.stroke();
      this.fill && ctx.fill();
      ctx.restore();
      this.onAfterRender && this.onAfterRender(ctx);
    }
  }, {
    key: "containPoint",
    value: function containPoint(ctx) {
      var point = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {
        x: 0,
        y: 0
      };
      ctx.save();
      ctx.beginPath();
      var firstPath = this.paths[0];

      if (firstPath) {
        firstPath.moveTo(ctx);
      }

      for (var i = 0; i < this.paths.length; i++) {
        this.paths[i].render(ctx);
      }

      if (this.closed) {
        ctx.closePath();
      }

      ctx.restore();

      if (ctx.isPointInPath(point.x, point.y)) {
        return true;
      }

      return false;
    }
  }, {
    key: "getVertices",
    value: function getVertices() {
      var vertices = [];
      this.paths.forEach(function (v) {
        if (v.start) {
          vertices.push([v.start.x, v.start.y]);
        }

        if (v.end) {
          vertices.push([v.end.x, v.end.y]);
        }

        if (v.controls && v.controls.length > 0) {
          v.controls.forEach(function (k) {
            vertices.push([k.x, k.y]);
          });
        }
      });
      return vertices;
    }
  }, {
    key: "getBoundingClientRect",
    value: function getBoundingClientRect() {
      var _this2 = this;

      var pixelVertices = this.getVertices();
      var parentVertices = pixelVertices.map(function (v) {
        var point = _this2.calcPixelToParentCoordinatePoint(v);

        return [point.x, point.y];
      });

      var _math$calcPointsRect = math.calcPointsRect(parentVertices),
          left = _math$calcPointsRect.left,
          right = _math$calcPointsRect.right,
          top = _math$calcPointsRect.top,
          bottom = _math$calcPointsRect.bottom;

      var res = {
        left: left,
        right: right,
        top: top,
        bottom: bottom,
        width: right - left,
        height: bottom - top
      };
      return res;
    }
  }, {
    key: "setCenter",
    value: function setCenter() {
      var _this$getBoundingClie = this.getBoundingClientRect(),
          width = _this$getBoundingClie.width,
          height = _this$getBoundingClie.height,
          left = _this$getBoundingClie.left,
          top = _this$getBoundingClie.top;

      var originPoint = this.calcPixelToParentCoordinatePoint([0, 0]);
      this.translation.x = originPoint.x - (left + 0.5 * width);
      this.translation.y = originPoint.y - (top + 0.5 * height);
    }
  }, {
    key: "clone",
    value: function clone() {
      var _this3 = this;

      var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          _ref$deep = _ref.deep,
          deep = _ref$deep === void 0 ? true : _ref$deep;

      var instance = get(getPrototypeOf(Path.prototype), "clone", this).call(this, {
        deep: deep
      });

      Object.keys(defaultConfig$1).forEach(function (key) {
        instance[key] = _this3[key];
      });
      instance.paths = this.paths.map(function (v) {
        return v.clone();
      });
      return instance;
    }
  }]);

  return Path;
}(Shape);

defineProperty(Path, "PATH_TYPE", {
  LINE: 'line',
  CURVE: 'curve',
  ARC: 'arc',
  ARC_TO: 'arcTo'
});

defineProperty(Path, "createElements", function () {
  var elements = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
  var paths = [];
  elements.forEach(function (v) {
    var element = null;
    var params = {
      id: v.id
    }; // line path

    if (v.type === Path.PATH_TYPE.LINE) {
      if (v.start) {
        params.start = Vector.formatPointIntoVector(v.start);
      }

      if (v.end) {
        params.end = Vector.formatPointIntoVector(v.end);
      }

      if (Path.Line.validateParams(params)) {
        element = new Path.Line(params);
      }
    } // curve path


    if (v.type === Path.PATH_TYPE.CURVE) {
      if (Array.isArray(v.controls)) {
        var controls = v.controls.map(function (k) {
          return Vector.formatPointIntoVector(k);
        });
        params.controls = controls;
      }

      if (v.start) {
        params.start = Vector.formatPointIntoVector(v.start);
      }

      if (v.end) {
        params.end = Vector.formatPointIntoVector(v.end);
      }

      if (Path.Curve.validateParams(params)) {
        element = new Path.Curve(params);
      }
    } // arcTo path


    if (v.type === Path.PATH_TYPE.ARC_TO) {
      if (Array.isArray(v.controls)) {
        var _controls = v.controls.map(function (k) {
          return Vector.formatPointIntoVector(k);
        });

        params.controls = _controls;
      }

      if (v.start) {
        params.start = Vector.formatPointIntoVector(v.start);
      }

      params.radius = v.radius;

      if (Path.ArcTo.validateParams(params)) {
        element = new Path.ArcTo(params);
      }
    } // arc path


    if (v.type === Path.PATH_TYPE.ARC) {
      if (v.start) {
        params.start = Vector.formatPointIntoVector(v.start);
      }

      params.x = v.x;
      params.y = v.y;
      params.radius = v.radius;
      params.startAngle = v.startAngle;
      params.endAngle = v.endAngle;
      params.anticlockwise = v.anticlockwise;

      if (Path.Arc.validateParams(params)) {
        element = new Path.Arc(params);
      }
    }

    element && paths.push(element);
  });
  return paths;
});

Path.Curve = CurvePath;
Path.Line = LinePath;
Path.Arc = ArcPath;
Path.ArcTo = ArcToPath;

function ownKeys$4(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread$4(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$4(Object(source), true).forEach(function (key) { defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$4(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }
var defaultConfig$2 = {
  x: 0,
  y: 0,
  width: 0,
  height: 0,
  center: true
};
var Rect =
/*#__PURE__*/
function (_Shape) {
  inherits(Rect, _Shape);

  function Rect() {
    var _this;

    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    classCallCheck(this, Rect);

    _this = possibleConstructorReturn(this, getPrototypeOf(Rect).call(this, options));

    var config = _objectSpread$4({}, defaultConfig$2, {}, options);

    Object.keys(defaultConfig$2).forEach(function (key) {
      _this[key] = config[key];
    });

    if (_this.center) {
      _this.setCenter();
    }

    return _this;
  }

  createClass(Rect, [{
    key: "render",
    value: function render(ctx) {
      this.onBeforeRender && this.onBeforeRender(ctx); // render

      ctx.save();
      var matrix = this.matrix.elements;
      ctx.transform(matrix[0], matrix[3], matrix[1], matrix[4], matrix[2], matrix[5]);
      ctx.beginPath();
      this.setCtxProps && this.setCtxProps(ctx);
      ctx.rect(this.x, this.y, this.width, this.height);
      this.fill && ctx.fill();
      this.stroke && ctx.stroke();
      ctx.restore(); // afterRender

      this.onAfterRender && this.onAfterRender(ctx);
    }
  }, {
    key: "containPoint",
    value: function containPoint(ctx) {
      var point = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {
        x: 0,
        y: 0
      };
      // ctx.save()
      // ctx.beginPath()
      // ctx.rect(this.x, this.y, this.width, this.height)
      // ctx.restore()
      var path = new Path2D();
      path.rect(this.x, this.y, this.width, this.height);

      if (ctx.isPointInPath(path, point.x, point.y)) {
        return true;
      }

      return false;
    }
  }, {
    key: "getBoundingClientRect",
    value: function getBoundingClientRect() {
      var _this2 = this;

      var pixelVertices = this.getVertices();
      var parentVertices = pixelVertices.map(function (v) {
        var point = _this2.calcPixelToParentCoordinatePoint(v);

        return [point.x, point.y];
      });

      var _math$calcPointsRect = math.calcPointsRect(parentVertices),
          left = _math$calcPointsRect.left,
          right = _math$calcPointsRect.right,
          top = _math$calcPointsRect.top,
          bottom = _math$calcPointsRect.bottom;

      var res = {
        left: left,
        right: right,
        top: top,
        bottom: bottom,
        width: right - left,
        height: bottom - top
      };
      return res;
    }
  }, {
    key: "getVertices",
    value: function getVertices() {
      return [[this.x, this.y], [this.x + this.width, this.y], [this.x + this.width, this.y + this.height], [this.x, this.y + this.height]];
    }
  }, {
    key: "setCenter",
    value: function setCenter() {
      this.translation.x = -this.width * 0.5;
      this.translation.y = -this.height * 0.5;
    }
  }, {
    key: "clone",
    value: function clone() {
      var _this3 = this;

      var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          _ref$deep = _ref.deep,
          deep = _ref$deep === void 0 ? true : _ref$deep;

      var instance = get(getPrototypeOf(Rect.prototype), "clone", this).call(this, {
        deep: deep
      });

      Object.keys(defaultConfig$2).forEach(function (key) {
        instance[key] = _this3[key];
      });
      return instance;
    }
  }]);

  return Rect;
}(Shape);

var RoundRect =
/*#__PURE__*/
function (_Path) {
  inherits(RoundRect, _Path);

  function RoundRect() {
    var _this;

    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    classCallCheck(this, RoundRect);

    _this = possibleConstructorReturn(this, getPrototypeOf(RoundRect).call(this, options));
    var _options$x = options.x,
        x = _options$x === void 0 ? 0 : _options$x,
        _options$y = options.y,
        y = _options$y === void 0 ? 0 : _options$y,
        _options$width = options.width,
        width = _options$width === void 0 ? 0 : _options$width,
        _options$height = options.height,
        height = _options$height === void 0 ? 0 : _options$height,
        _options$radius = options.radius,
        radius = _options$radius === void 0 ? 0 : _options$radius; // create paths

    _this.paths = Path.createElements([{
      type: 'arcTo',
      id: '0',
      start: [x, y + radius],
      controls: [[x, y], [x + radius, y]],
      radius: radius
    }, {
      type: 'line',
      id: '1',
      end: [x + width - radius, y]
    }, {
      type: 'arcTo',
      id: '2',
      controls: [[x + width, y], [x + width, y + radius]],
      radius: radius
    }, {
      type: 'line',
      id: '3',
      end: [x + width, y + height - radius]
    }, {
      type: 'arcTo',
      id: '4',
      controls: [[x + width, y + height], [x + width - radius, y + height]],
      radius: radius
    }, {
      type: 'line',
      id: '5',
      end: [x + radius, y + height]
    }, {
      type: 'arcTo',
      id: '6',
      controls: [[x, y + height], [x, y + height - radius]],
      radius: radius
    }, {
      type: 'line',
      id: '7',
      end: [x, y + radius]
    }]);
    return _this;
  }

  return RoundRect;
}(Path);

var Polygon =
/*#__PURE__*/
function (_Path) {
  inherits(Polygon, _Path);

  function Polygon() {
    var _this;

    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    classCallCheck(this, Polygon);

    _this = possibleConstructorReturn(this, getPrototypeOf(Polygon).call(this, options));
    var closed = options.closed,
        _options$points = options.points,
        points = _options$points === void 0 ? [] : _options$points;
    _this.closed = closed !== undefined ? closed : true;
    var formatedPoints = Polygon.formatPolyPoints(points);
    _this.paths = Path.createElements(formatedPoints);
    return _this;
  }

  createClass(Polygon, [{
    key: "updatePaths",
    value: function updatePaths() {
      var points = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
      var formatedPoints = Polygon.formatPolyPoints(points);
      this.paths = Path.createElements(formatedPoints);
    }
  }, {
    key: "clone",
    value: function clone() {
      var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          _ref$deep = _ref.deep,
          deep = _ref$deep === void 0 ? true : _ref$deep;

      var instance = get(getPrototypeOf(Polygon.prototype), "clone", this).call(this, {
        deep: deep
      });

      instance.closed = this.closed;
      return instance;
    }
  }]);

  return Polygon;
}(Path);

defineProperty(Polygon, "formatPolyPoints", function () {
  var points = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
  var elements = [];
  points.forEach(function (v, index) {
    var element;

    if (index === 0) {
      element = {
        type: 'line',
        id: index,
        start: v
      };
    } else if (index === 1) {
      if (elements[0]) {
        elements[0].end = v;
      }
    } else {
      element = {
        type: 'line',
        id: index,
        end: v
      };
    }

    element && elements.push(element);
  });
  return elements;
});

function ownKeys$5(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread$5(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$5(Object(source), true).forEach(function (key) { defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$5(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }
var defaultConfig$3 = {
  x: 0,
  y: 0,
  radius: 0,
  anticlockwise: false,
  startAngle: 0,
  endAngle: Math.PI * 2
};
var Arc =
/*#__PURE__*/
function (_Shape) {
  inherits(Arc, _Shape);

  function Arc() {
    var _this;

    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    classCallCheck(this, Arc);

    _this = possibleConstructorReturn(this, getPrototypeOf(Arc).call(this, options));

    var config = _objectSpread$5({}, defaultConfig$3, {}, options);

    Object.keys(defaultConfig$3).forEach(function (key) {
      _this[key] = config[key];
    });
    return _this;
  }

  createClass(Arc, [{
    key: "render",
    value: function render(ctx) {
      this.onBeforeRender && this.onBeforeRender(ctx);
      ctx.save();
      var matrix = this.matrix.elements;
      ctx.transform(matrix[0], matrix[3], matrix[1], matrix[4], matrix[2], matrix[5]);
      ctx.beginPath();
      this.setCtxProps && this.setCtxProps(ctx);
      ctx.arc(this.x, this.y, this.radius, this.startAngle, this.endAngle, this.anticlockwise);
      this.closed && ctx.closePath();
      this.fill && ctx.fill();
      this.stroke && ctx.stroke();
      ctx.restore();
      this.onAfterRender && this.onAfterRender(ctx);
    }
  }, {
    key: "clone",
    value: function clone() {
      var _this2 = this;

      var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          _ref$deep = _ref.deep,
          deep = _ref$deep === void 0 ? true : _ref$deep;

      var instance = get(getPrototypeOf(Arc.prototype), "clone", this).call(this, {
        deep: deep
      });

      Object.keys(defaultConfig$3).forEach(function (key) {
        instance[key] = _this2[key];
      });
      return instance;
    }
  }]);

  return Arc;
}(Shape);

function ownKeys$6(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread$6(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$6(Object(source), true).forEach(function (key) { defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$6(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }
var defaultConfig$4 = {
  anticlockwise: true,
  startAngle: 0,
  endAngle: Math.PI * 2
};
var Circle =
/*#__PURE__*/
function (_Arc) {
  inherits(Circle, _Arc);

  function Circle() {
    var _this;

    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    classCallCheck(this, Circle);

    _this = possibleConstructorReturn(this, getPrototypeOf(Circle).call(this, options));

    var config = _objectSpread$6({}, defaultConfig$4, {}, options);

    Object.keys(defaultConfig$4).forEach(function (key) {
      _this[key] = config[key];
    });
    return _this;
  }

  createClass(Circle, [{
    key: "containPoint",
    value: function containPoint(ctx) {
      var point = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {
        x: 0,
        y: 0
      };
      var path = new Path2D();
      path.arc(this.x, this.y, this.radius, this.startAngle, this.endAngle, this.anticlockwise);

      if (ctx.isPointInPath(path, point.x, point.y)) {
        return true;
      }

      return false;
    }
  }, {
    key: "getBoundingClientRect",
    value: function getBoundingClientRect() {
      var res = {
        left: this.x - this.radius,
        right: this.x + this.radius,
        top: this.y - this.radius,
        bottom: this.y + this.radius,
        width: 2 * this.radius,
        height: 2 * this.radius
      };
      return res;
    }
  }, {
    key: "clone",
    value: function clone() {
      var _this2 = this;

      var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          _ref$deep = _ref.deep,
          deep = _ref$deep === void 0 ? true : _ref$deep;

      var instance = get(getPrototypeOf(Circle.prototype), "clone", this).call(this, {
        deep: deep
      });

      Object.keys(defaultConfig$4).forEach(function (key) {
        instance[key] = _this2[key];
      });
      return instance;
    }
  }]);

  return Circle;
}(Arc);

function ownKeys$7(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread$7(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$7(Object(source), true).forEach(function (key) { defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$7(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }
var defaultConfig$5 = {
  x: 0,
  y: 0,
  radiusX: 0,
  radiusY: 0,
  anticlockwise: false,
  startAngle: 0,
  endAngle: Math.PI * 2,
  rotation: 0
};
var Ellipse =
/*#__PURE__*/
function (_Shape) {
  inherits(Ellipse, _Shape);

  function Ellipse() {
    var _this;

    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    classCallCheck(this, Ellipse);

    _this = possibleConstructorReturn(this, getPrototypeOf(Ellipse).call(this, options));

    var config = _objectSpread$7({}, defaultConfig$5, {}, options);

    Object.keys(defaultConfig$5).forEach(function (key) {
      _this[key] = config[key];
    });
    return _this;
  }

  createClass(Ellipse, [{
    key: "render",
    value: function render(ctx) {
      this.onBeforeRender && this.onBeforeRender(ctx);
      ctx.save();
      var matrix = this.matrix.elements;
      ctx.transform(matrix[0], matrix[3], matrix[1], matrix[4], matrix[2], matrix[5]);
      ctx.beginPath();
      this.setCtxProps && this.setCtxProps(ctx);
      ctx.ellipse(this.x, this.y, this.radiusX, this.radiusY, 0, this.startAngle, this.endAngle, this.anticlockwise);
      this.close && ctx.closePath();
      this.fill && ctx.fill();
      this.stroke && ctx.stroke();
      ctx.restore();
      this.onAfterRender && this.onAfterRender(ctx);
    }
  }, {
    key: "containPoint",
    value: function containPoint(ctx) {
      var point = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {
        x: 0,
        y: 0
      };
      var path = new Path2D();
      path.ellipse(this.x, this.y, this.radiusX, this.radiusY, 0, this.startAngle, this.endAngle, this.anticlockwise);

      if (ctx.isPointInPath(path, point.x, point.y)) {
        return true;
      }

      return false;
    }
  }, {
    key: "clone",
    value: function clone() {
      var _this2 = this;

      var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          _ref$deep = _ref.deep,
          deep = _ref$deep === void 0 ? true : _ref$deep;

      var instance = get(getPrototypeOf(Ellipse.prototype), "clone", this).call(this, {
        deep: deep
      });

      Object.keys(defaultConfig$5).forEach(function (key) {
        instance[key] = _this2[key];
      });
      return instance;
    }
  }]);

  return Ellipse;
}(Shape);

function ownKeys$8(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread$8(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$8(Object(source), true).forEach(function (key) { defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$8(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var defaultConfig$6 = {
  text: '',
  x: 0,
  y: 0,
  maxWidth: undefined,
  fillText: true,
  strokeText: false,
  fillStyle: '#000',
  font: '10px sans-serif',
  textAlign: 'start',
  textBaseline: 'alphabetic',
  direction: 'ltr'
};
var Text =
/*#__PURE__*/
function (_Shape) {
  inherits(Text, _Shape);

  function Text() {
    var _this;

    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    classCallCheck(this, Text);

    _this = possibleConstructorReturn(this, getPrototypeOf(Text).call(this, options));

    var config = _objectSpread$8({}, defaultConfig$6, {}, options);

    Object.keys(defaultConfig$6).forEach(function (key) {
      _this[key] = config[key];
    });
    return _this;
  }

  createClass(Text, [{
    key: "render",
    value: function render(ctx) {
      this.onBeforeRender && this.onBeforeRender(ctx);
      ctx.save();
      var matrix = this.matrix.elements;
      ctx.transform(matrix[0], matrix[3], matrix[1], matrix[4], matrix[2], matrix[5]);
      this.setCtxProps && this.setCtxProps(ctx);
      this.setTextCtxProps && this.setTextCtxProps(ctx);

      if (this.maxWidth) {
        this.fillText && ctx.fillText(this.text, this.x, this.y, this.maxWidth);
        this.strokeText && ctx.strokeText(this.text, this.x, this.y, this.maxWidth);
      } else {
        this.fillText && ctx.fillText(this.text, this.x, this.y);
        this.strokeText && ctx.strokeText(this.text, this.x, this.y);
      }

      ctx.restore();
      this.onAfterRender && this.onAfterRender(ctx);
    }
  }, {
    key: "setTextCtxProps",
    value: function setTextCtxProps(ctx) {
      if (this.font) {
        ctx.font = this.font;
      }

      if (this.textAlign) {
        ctx.textAlign = this.textAlign;
      }

      if (this.textBaseline) {
        ctx.textBaseline = this.textBaseline;
      }

      if (this.direction) {
        ctx.direction = this.direction;
      }
    }
  }, {
    key: "containPoint",
    value: function containPoint() {
      return false;
    }
  }, {
    key: "clone",
    value: function clone() {
      var _this2 = this;

      var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          _ref$deep = _ref.deep,
          deep = _ref$deep === void 0 ? true : _ref$deep;

      var instance = get(getPrototypeOf(Text.prototype), "clone", this).call(this, {
        deep: deep
      });

      Object.keys(defaultConfig$6).forEach(function (key) {
        instance[key] = _this2[key];
      });
      return instance;
    }
  }]);

  return Text;
}(Shape);

function ownKeys$9(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread$9(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys$9(Object(source), true).forEach(function (key) { defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys$9(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }
var defaultConfig$7 = {
  image: null,
  sx: null,
  sy: null,
  sWidth: null,
  sHeight: null,
  x: 0,
  y: 0,
  width: null,
  height: null
};
var Image =
/*#__PURE__*/
function (_Shape) {
  inherits(Image, _Shape);

  function Image() {
    var _this;

    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    classCallCheck(this, Image);

    _this = possibleConstructorReturn(this, getPrototypeOf(Image).call(this, options));

    var config = _objectSpread$9({}, defaultConfig$7, {}, options);

    Object.keys(defaultConfig$7).forEach(function (key) {
      _this[key] = config[key];
    });
    _this.loaded = false;
    return _this;
  }

  createClass(Image, [{
    key: "render",
    value: function render(ctx) {
      var _this2 = this;

      this.onBeforeRender && this.onBeforeRender(ctx);
      ctx.save();
      var matrix = this.matrix.elements;
      ctx.transform(matrix[0], matrix[3], matrix[1], matrix[4], matrix[2], matrix[5]);

      if (['width', 'height'].some(function (v) {
        return _this2[v] === null;
      })) {
        ctx.drawImage(this.image, this.x, this.y);
      } else {
        if (['sx', 'sy', 'sWidth', 'sHeight'].every(function (v) {
          return _this2[v] !== null;
        })) {
          ctx.drawImage(this.image, this.sx, this.sy, this.sWidth, this.sHeight, this.x, this.y, this.width, this.height);
        } else {
          ctx.drawImage(this.image, this.x, this.y, this.width, this.height);
        }
      }

      ctx.restore();
      this.onAfterRender && this.onAfterRender(ctx);
    }
  }, {
    key: "containPoint",
    value: function containPoint(ctx) {
      var point = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {
        x: 0,
        y: 0
      };
      // ctx.save()
      // ctx.beginPath()
      // ctx.rect(this.x, this.y, this.width, this.height)
      // ctx.restore()
      var path = new Path2D();
      path.rect(this.x, this.y, this.width, this.height);

      if (ctx.isPointInPath(path, point.x, point.y)) {
        return true;
      }

      return false;
    }
  }, {
    key: "set",
    value: function set(key, value) {
      var _this3 = this;

      if (_typeof_1(key) === 'object') {
        Object.keys(key).forEach(function (v) {
          _this3[v] = key[v];
        });
      } else {
        this[key] = value;
      }

      return this;
    }
  }, {
    key: "clone",
    value: function clone() {
      var _this4 = this;

      var _ref = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {},
          _ref$deep = _ref.deep,
          deep = _ref$deep === void 0 ? true : _ref$deep;

      var instance = get(getPrototypeOf(Image.prototype), "clone", this).call(this, {
        deep: deep
      });

      Object.keys(defaultConfig$7).forEach(function (key) {
        instance[key] = _this4[key];
      });
      return instance;
    }
  }], [{
    key: "load",
    value: function load(url, callback) {
      var global = window || global;
      var img = new global.Image();
      img.src = url;

      if (img.complete) {
        callback(img);
      } else {
        img.onload = function () {
          callback(img);
        };
      }
    }
  }]);

  return Image;
}(Shape);

Malyan.Vector = Vector;
Malyan.Group = Group;
Malyan.Shape = Shape;
Malyan.Line = Line;
Malyan.Curve = Curve;
Malyan.Path = Path;
Malyan.Rect = Rect;
Malyan.RoundRect = RoundRect;
Malyan.Polygon = Polygon;
Malyan.Arc = Arc;
Malyan.Circle = Circle;
Malyan.Ellipse = Ellipse;
Malyan.Text = Text;
Malyan.Image = Image;
Malyan.Matrix = Matrix;
Malyan.math = math;

exports.Arc = Arc;
exports.Circle = Circle;
exports.Curve = Curve;
exports.Ellipse = Ellipse;
exports.Group = Group;
exports.Image = Image;
exports.Line = Line;
exports.Malyan = Malyan;
exports.Matrix = Matrix;
exports.Path = Path;
exports.Polygon = Polygon;
exports.Rect = Rect;
exports.RoundRect = RoundRect;
exports.Shape = Shape;
exports.Text = Text;
exports.Vector = Vector;
exports.default = Malyan;
exports.math = math;
